 //Robo Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//Information of one play
//
public class ReplayInfo extends Observable{

	static protected String	teamName[] = new String[2];
	protected	int	score[] = new int[2];
	protected 	int 	time;
	protected 	String	pmode; 

	protected	double minBallDist;

	protected 	CPlayer[] player = new CPlayer[22];
	protected 	CBall cball;	

	protected 	boolean kicked;	
		
	protected	int kickMember;

	//protected   ReplayInfo before;

	ReplayInfo(){
			
		for(int i = 0; i < 2; ++i){
			teamName[i] = new String();
		} 
		   
		cball = new CBall(this);

		for (int i = 0; i <= 21; ++i){
			player[i] = new CPlayer(this);
		}			
	}

	//֥СΤ򤹤
	public void changes(){

		setChanged();
		notifyObservers();
	}

	String getTeamName(int side){

		int si = (side == CParam.CType_LEFT)? 0 : 1;
		//ꤷźϰǤ뤫ɤ
		if ((si > 1) || (si < 0)){
			String s = "ReplayInfo饹getTeamName᥽åɤϤͤ۾Ǥ";
			throw new IllegalArgumentException(s);
			}

		return teamName[si]; 

	}

	 CBall getCBall(){

		return cball;
	}
	
	
	int getScore(int side){

		return score[side]; 
	}

	int getTime(){
		return time;	
	}
	
	String getPlayMode(){
		return pmode;
	}

	int getPlayerKickCount(int index){
		return player[index].getKickCount();
	}
			
	int getTeamKickCount(int side){
		
		int total = 0;
		int base = (side == CParam.CType_LEFT)? 0 : 11;
		for(int i = 0; i <= 10; ++i){
			total = total += player[base + i].getKickCount();			
		}
		return total;
	}
	int getPlayerDistance(int index){
		return player[index].getDistance();
	}

	int getTeamDistance(int side){
		int total = 0;
		int base = (side == CParam.CType_LEFT)? 0 : 11;

		for(int i = 0; i <= 10; ++i){
			total = total += player[base + i].getDistance();			
		}
		return total;
	}
		
	void drawAll(Graphics g){

		for (int i = 0; i <= 21; ++i){
			player[i].drawPlayer(g);
		}	
		
		cball.drawBall(g);
	}

	//Team̾򥻥åȤ
	void setTeamName(int teamSide, String teamName){

		//ꤷźϰǤ뤫ɤ
		if ((teamSide > 1) || (teamSide < 0)){
			System.out.println(teamSide+"ReplayInfo饹setTeamName᥽åɤϤͤ۾Ǥ");
			}

		this.teamName[teamSide]  = teamName; 

	}

	void setCBall(int x, int y){

		cball.set(x, y);
	}

	void setPlayer(int index, int x, int y, int angle, int side, int unum, Color c, int enable){

		if(index == 0){minBallDist = 10000;}  
		if (player[index].set(x, y, angle, side, unum, c,enable, time) == true){

			if (player[index].toBallDist < minBallDist){
				kicked = true;	
				minBallDist = player[index].toBallDist; 		
				kickMember = index;
			}
		}

	}	

	void setTime(int time){

		this.time = time;
	}
	
	void setPlayMode(String pmode){

		this.pmode = pmode; 
	}

	void setScore(int teamSide, int teamScore){

		score[teamSide] = teamScore;

	}
		
}




